
/*
 * Show Desktop from Overview
 * Very small extension which minimizes all windows when you click on an empty space in the windows-overview-mode.
 * Version for Gnome-Shell 3.6
*/

const Main = imports.ui.main;

var connectid = null;
var reactiveBefore = null;

function _showDesktop() {
    let activeWorkspace = global.screen.get_active_workspace();
    let windows = activeWorkspace.list_windows();
    for (let i = 0; i < windows.length; i++) {
           if (!windows[i].minimized) {
	       windows[i].minimize();
           }
    }
    Main.overview.hide();
}

function init() {
    reactiveBefore=Main.overview._viewSelector._workspacesDisplay.actor.reactive;
    //normal: false. but maybe set by another extension.
}

function enable() {
    Main.overview._viewSelector._workspacesDisplay.actor.reactive=true;
    connectid = Main.overview._viewSelector._workspacesDisplay.actor.connect('button-press-event', _showDesktop);
}

function disable() {
    //set back to default value which is normally false.
    Main.overview._viewSelector._workspacesDisplay.actor.reactive=reactiveBefore;
    Main.overview._viewSelector._workspacesDisplay.actor.disconnect(connectid);
}
